var f = Object.defineProperty;
var m = (e, t, n) => t in e ? f(e, t, { enumerable: !0, configurable: !0, writable: !0, value: n }) : e[t] = n;
var c = (e, t, n) => m(e, typeof t != "symbol" ? t + "" : t, n);
var g = /* @__PURE__ */ ((e) => (e.IN = "in", e.OUT = "out", e))(g || {}), I = /* @__PURE__ */ ((e) => (e.NUMBER = "number", e.NUMBER_ARRAY = "numberarray", e.STRING = "string", e.STRING_ARRAY = "stringarray", e.BOOLEAN = "boolean", e.BOOLEAN_ARRAY = "booleanarray", e.OBJECT = "object", e.OBJECT_ARRAY = "objectarray", e.UNDEFINED = "undefined", e))(I || {}), l = /* @__PURE__ */ ((e) => (e.STARTED = "started", e.RUNNING = "running", e.FINISHED_SUCCESSFULLY = "finishedSuccessfully", e.FINISHED_WITH_ERRORS = "finishedWithErrors", e))(l || {}), B = /* @__PURE__ */ ((e) => (e.START = "start", e.CRON = "cron", e))(B || {});
function E(e) {
  return typeof e.getTriggerName == "function";
}
var b = /* @__PURE__ */ ((e) => (e.INFO = "info", e.DEBUG = "debug", e.WARN = "warn", e.ERROR = "error", e))(b || {});
class S {
  constructor() {
    c(this, "logs", []);
    c(this, "blockId");
    c(this, "blockName");
    c(this, "socketName");
  }
  setContext(t, n, s) {
    this.blockId = t, this.blockName = n, this.socketName = s;
  }
  async addLog(t) {
    this.logs.push(t);
  }
  async debug(t, n) {
    this.logs.push({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: t,
      extra: n,
      timestamp: Date.now(),
      level: "debug"
      /* DEBUG */
    });
  }
  async error(t, n) {
    this.logs.push({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: t,
      extra: n,
      timestamp: Date.now(),
      level: "error"
      /* ERROR */
    });
  }
  async info(t, n) {
    this.logs.push({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: t,
      extra: n,
      timestamp: Date.now(),
      level: "info"
      /* INFO */
    });
  }
  async warn(t, n) {
    this.logs.push({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: t,
      extra: n,
      timestamp: Date.now(),
      level: "warn"
      /* WARN */
    });
  }
  getLogs() {
    return this.logs;
  }
}
class U {
  constructor() {
    c(this, "blockDefinitions", {});
  }
  addBlockDefinition(t, n) {
    this.blockDefinitions[t] = n;
  }
  async getBlockDefinition(t) {
    const n = this.blockDefinitions[t];
    if (!n) throw new Error("block definition not found by id: " + t);
    return n;
  }
  getBlockById(t, n) {
    const s = t.blocks.find((o) => o.id === n);
    if (!s) throw new Error("block not found by id: " + n);
    return s;
  }
  getSocketConnectionsBySource(t, n, s) {
    return t.connections && t.connections.filter(
      (o) => o.sourceBlockId === n && o.sourceSocketName === s
    );
  }
  getLogger() {
    return new S();
  }
  // eslint-disable-next-line max-lines-per-function
  async triggerWorkflowBlock(t, n, s, o) {
    o === void 0 && (o = { logger: this.getLogger() });
    const r = this.getBlockById(t, n);
    if (!r) throw new Error("Block not found by blockId: " + n);
    const u = await this.getBlockDefinition(r.definitionId);
    if (!u) throw new Error("BlockDefinition not found by block.definitionId: " + r.definitionId);
    if (o.logger.setContext(n, r.definitionId, s.socketName), await o.logger.info(
      `Executing block "${r.definitionId}", socket: ${s.socketName}`,
      JSON.stringify(
        {
          blockId: n,
          data: s.data,
          configuration: r.configuration
        },
        void 0,
        2
      ).substring(0, 2048)
    ), u.getSockets().find(
      (i) => i.name === s.socketName && i.direction === g.IN
    ) === void 0)
      throw new Error("block '" + n + "' has no input socket with name " + s.socketName);
    if (t.connections instanceof Array)
      for (const i of t.connections) {
        const h = this.getBlockById(t, i.sourceBlockId);
        if ((await this.getBlockDefinition(h.definitionId)).getSockets().find(
          (d) => d.name === i.sourceSocketName && d.direction === g.OUT
        ) === void 0)
          throw new Error(
            "block '" + i.sourceBlockId + "' has no output socket with name " + i.sourceSocketName
          );
        const N = this.getBlockById(t, i.targetBlockId);
        if ((await this.getBlockDefinition(N.definitionId)).getSockets().find(
          (d) => d.name === i.targetSocketName && d.direction === g.IN
        ) === void 0)
          throw new Error(
            "block '" + i.targetBlockId + "' has no input socket with name " + i.targetSocketName
          );
      }
    let a;
    try {
      s.configuration = r.configuration, a = await u.executeBlock(s, o);
    } catch (i) {
      return await o.logger.error("Uncaught Exception: " + i.message), {
        logs: o.logger.getLogs(),
        data: void 0,
        status: l.FINISHED_WITH_ERRORS
      };
    }
    if (a)
      if (a.socketName) {
        const i = this.getSocketConnectionsBySource(
          t,
          n,
          a.socketName
        );
        if (i instanceof Array && i.length > 0) {
          if (i.length > 1) throw new Error("more than one output connection is currently not allowed");
          const h = {
            socketName: i[0].targetSocketName,
            data: a.data
          };
          return this.triggerWorkflowBlock(
            t,
            i[0].targetBlockId,
            h,
            o
          );
        } else
          return {
            data: a.data,
            logs: o.logger.getLogs(),
            status: l.FINISHED_SUCCESSFULLY
          };
      } else
        return {
          data: a.data,
          logs: o.logger.getLogs(),
          status: l.FINISHED_SUCCESSFULLY
        };
    return {
      logs: o.logger.getLogs(),
      data: void 0,
      status: l.FINISHED_SUCCESSFULLY
    };
  }
}
function k(e, t, n) {
  return {
    direction: n,
    name: e,
    type: t
  };
}
function O(e, t) {
  return k(e, t, g.IN);
}
function A(e, t) {
  return k(e, t, g.OUT);
}
export {
  S as DefaultWorkflowLogger,
  g as SocketDirection,
  I as SocketType,
  U as WorkflowEngine,
  l as WorkflowExecutionStatus,
  b as WorkflowLogLevel,
  B as WorkflowTriggerNames,
  O as createInputSocket,
  A as createOutputSocket,
  k as createSocket,
  E as isWorkflowTriggerBlock
};
